Loading...
Searching...
No Matches
Sap4HanaRestClient::Sap4HanaRestConnection Class Reference

class for SAP S/4Hana REST connections; returns Sap4HanaRestClient::Sap4HanaRestClient objects More...

## Public Member Functions

| constructor (hash< auto > config, *hash< auto > attr)
| creates the Sap4HanaRestConnection object
| constructor (string name, string description, string url, hash< auto > attributes={}, hash< auto > options={})
| creates the Sap4HanaRestConnection object
string | getOAuth2OptionName (string opt)
| Returns the OAuth2 option name for this connection.
hash< auto > | getOAuth2Options ()
| Returns OAuth2 options in a standard format.
string | getType ()
| returns `"sap4hanarests"`

## Public Attributes

const | ConnectionScheme = ...
| Connection entry info.
const | OAuth2AuthRequestOptions = ...
| options required to support the OAuth2 authorization code grant flow
const | OAuth2DifferentOptionMap = map {$1.value: $1.key}
| Different OAuth2 option map; standard name => extern name.
const | OAuth2Options = ...
| Maps SAP REST options to standard options.
const | OAuth2StandardToSapOptionMap = map {$1.value: $1.key}
| Maps standard option names to SAP REST option names.

## Protected Member Functions

hash< ConnectionSchemeInfo > | getConnectionSchemeInfoImpl ()
| Returns the ConnectionSchemeInfo hash for this object.
Sap4HanaRestClient | getImpl (bool connect=True, *hash< auto > rtopts)
| returns a Sap4HanaRestClient::Sap4HanaRestClient object

## Detailed Description

class for SAP S/4Hana REST connections; returns Sap4HanaRestClient::Sap4HanaRestClient objects

In addition to all options supported by RestClientConnection, this connection class supports the following options:

- `"apikey"`: (required if `"client_id"` and `"client_secret"` are not supplied) the SAP S/4Hana api key
- `"client_id"`: (required if `"apikey"` is not supplied) the SAP S/4Hana OAuth2 client ID
- `"client_secret"`: (required if `"apikey"` is not supplied) the SAP S/4Hana OAuth2 client secret

See also
  Sap4HanaRestClient::constructor() for more information on the above options

## Member Function Documentation

## constructor() [1/2]

Sap4HanaRestClient::Sap4HanaRestConnection::constructor | ( | hash< auto > | config,
|  | *hash< auto > | attr )

creates the Sap4HanaRestConnection object

Parameters

  config

  with the following keys:
  - name (required string): the connection name
  - display_name (optional string): the display name
  - short_desc (optional string): a short description in plain text
  - desc (optional string): a long description with markdown formatting
  - url (required string): the connection URL
  - opts (optional hash): connection options
  - logger (optional LoggerInterface object): logger for the connection

  attr

  optional connection attributes
  - monitor (optional bool): should the connection be monitored? Default: True
  - enabled (optional bool): is the connection enabled? Default: True
  - locked (optional bool): is the connection locked? Default: False
  - debug_data (optional bool): debug data? Default: False
  - tags (optional hash): tags for the connection; no default value

Exceptions

  CONNECTION-OPTION-ERROR | missing or invalid connection option or attribute

## constructor() [2/2]

Sap4HanaRestClient::Sap4HanaRestConnection::constructor | ( | string | name,
|  | string | description,
|  | string | url,
|  | hash< auto > | attributes = {},
|  | hash< auto > | options = {} )

creates the Sap4HanaRestConnection object

Parameters

  name | the name of the connection
  description | connection description
  url | connection URL (potentially with password info)
  attributes | various attributes. See below
  options | connection options

See AbstractConnection::constructor() for `attributes` and `options` reference.

Exceptions

  CONNECTION-OPTION-ERROR | missing or invalid connection option

## getImpl()

Sap4HanaRestClient Sap4HanaRestClient::Sap4HanaRestConnection::getImpl | ( | bool | connect = True,
|  | *hash< auto > | rtopts )

protected

returns a Sap4HanaRestClient::Sap4HanaRestClient object

Parameters

  connect | if True, then the connection is returned already connected
  rtopts | this connection type does not accept any runtime options, so this parameter is ignored

Returns
  a Sap4HanaRestClient object

## getOAuth2OptionName()

string Sap4HanaRestClient::Sap4HanaRestConnection::getOAuth2OptionName | ( | string | opt | ) |

Returns the OAuth2 option name for this connection.

Since
  SapRestClient 2.0

## getOAuth2Options()

hash< auto > Sap4HanaRestClient::Sap4HanaRestConnection::getOAuth2Options | ( |  | ) |

Returns OAuth2 options in a standard format.

Since
  SapRestClient 2.0